/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Name:				sylex3_csr.wdl																														//
// Programmierer:	Leopold Sebastian																														//
// Copyright:		Copyright  2005 by Light Entertainment																						//
//-------------------------------------------------------------------------------------------------------------------------//
// Beschreibung:	Debugfunktionen von Sunset Down																									//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ifndef _SYLEX3_CSR;
define _SYLEX3_CSR;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dllfunction Prototypes:

// Grundfunktionen:
dllfunction SLX3Initialize(var_ode,str_title);
dllfunction SLX3DeInitialize(void_var);
dllfunction SLX3ReleaseResources(void_var);
dllfunction SLX3RecreateResources(void_var);
dllfunction SLX3ReleaseMemory(void_var);
dllfunction SLX3SwitchResolution(var_videomode);

// Viewverwaltungsfunktionen
dllfunction SLX3ViewRegister(var_id,str_viewname);
dllfunction SLX3ViewUnregister(var_id);
dllfunction SLX3ViewSetClipPlane(var_id,str_vecPoint,str_vecNormal,var_use);
dllfunction SLX3ViewSetMirrorPlane(var_id,str_vecPoint,str_vecNormal,var_use);
dllfunction SLX3ViewSetHDR(ID,Use);
dllfunction SLX3ViewSetPostProcessing(var_id,var_use);
dllfunction SLX3ViewSetRTT(var_id,var_use);
dllfunction SLX3ViewSetSmoothShadows(var_id,var_use);
dllfunction SLX3ViewSetPostProcessingEffect(var_id,var_slot,var_effectID);
dllfunction SLX3ViewSetRenderToDepthTexture(var_id,var_use);

// Texturverwaltungsfunktionen
dllfunction SLX3TexCreate(var_id,var_type);
dllfunction SLX3TexDelete(var_id);
dllfunction SLX3TexInitialize(var_id);
dllfunction SLX3TexSetPath(var_id,str_path);
dllfunction SLX3TexSetFormat(var_id,var_format);
dllfunction SLX3TexSetSize(var_id,var_sizeX,var_sizeY);
dllfunction SLX3TexSetUsage(var_id,var_usage);
dllfunction SLX3TexSetViewID(var_id,var_side,var_viewID);

// Effektverwaltung
dllfunction SLX3EffectCreate(var_id);
dllfunction SLX3EffectDelete(var_id);
dllfunction SLX3EffectInitialize(var_id);
dllfunction SLX3EffectSetPath(var_id,str_path);
dllfunction SLX3EffectSetValue(var_id,var_valueID,var_value);
dllfunction SLX3EffectSetTex(var_id,var_stage,var_textureID);

// Rendercore
dllfunction SLX3RenderDrawA(void_var);
dllfunction SLX3RenderDrawB(void_var);
dllfunction SLX3RenderDrawC(void_var);
dllfunction SLX3RenderDrawD(void_var);
dllfunction SLX3RenderDrawE(var_id);
dllfunction SLX3RenderSetShadowColor(red,green,blue);
dllfunction SLX3RenderSetShadowAlpha(alpha);

// Objektverwaltung
dllfunction SLX3ObjectCreate(var_id,var_type);
dllfunction SLX3ObjectDelete(var_id);
dllfunction SLX3ObjectInitialize(var_id);
dllfunction SLX3ObjectSetEffect(var_id,var_effectID);
dllfunction SLX3ObjectSetTexture(var_id,var_stage,var_textureID);
dllfunction SLX3ObjectSetSkill(var_id,var_skill,var_value);
dllfunction SLX3ObjectSetFlag(var_id,var_flag,var_value);
dllfunction SLX3ObjectSetPosition(var_id,var_x,var_y,var_z);
dllfunction SLX3ObjectSetRotation(var_id,var_pan,var_tilt,var_roll);
dllfunction SLX3ObjectSetScalation(var_id,var_scaleX,var_scaleY,var_scaleZ);

// Materialverwaltung
dllfunction SLX3MaterialRegister(ID,Name);
dllfunction SLX3MaterialUnregister(ID);

// Scriptverwaltung
dllfunction SLX3ScriptCreate(ID,Type);
dllfunction SLX3ScriptSetPath(ID,strPath);
dllfunction SLX3ScriptInterpret(ID);
dllfunction SLX3ScriptDelete(ID);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 3DGS Funktionspointerzuweiungen
on_d3d_lost  = SLX3ReleaseResources;
on_d3d_reset = SLX3RecreateResources;

render_sky 		=		SLX3RenderDrawA;
render_world 		= 		SLX3RenderDrawB;
render_solid 		=		SLX3RenderDrawC;
render_entities 	= 		SLX3RenderDrawD;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Definitionen fr Typen in Sylex 3.0
define SLX3_RUNMODE_DEBUG,			1;
define SLX3_RUNMODE_RELEASE,			0;

define SLX3FMT_R8G8B8, 				0;
define SLX3FMT_X8R8G8B8, 			1;
define SLX3FMT_A8R8G8B8, 			2;
define SLX3FMT_V8U8,				3;
define SLX3FMT_CxV8U8,				4;
define SLX3FMT_R16F,				5;
define SLX3FMT_G16R16F,				6;
define SLX3FMT_A16B16G16R16F,			7;
define SLX3FMT_Q8W8V8U8,			8;
define SLX3FMT_R32F,				9;

define SLX3TS_FRONT,				0;
define SLX3TS_BACK,				1;
define SLX3TS_RIGHT,				2;
define SLX3TS_LEFT,				3;
define SLX3TS_TOP,				4;
define SLX3TS_BOTTOM,				5;

define SLX3TT_NORMAL,				0;
define SLX3TT_CUBE,				1;
define SLX3TT_VOLUME,				2;

define SLX3OT_SKY,				1;
define SLX3OT_WATER,				2;
define SLX3OT_A6MESH,				3;

define SLX3ST_POSTPROCESS,			0;
define SLX3ST_HDR,				1;

define SLX3_PPE_4XDOWNSAMPLE,			30000;
define SLX3_PPE_2XDOWNSAMPLE,			30001;
define SLX3_PPE_BRIGHTPASS,			30002;
define SLX3_PPE_TONEMAPPING,			30003;
define SLX3_PPE_VBLOOM,				30004;
define SLX3_PPE_HBLOOM,				30005;
define SLX3_PPE_HBLUR,				30006;
define SLX3_PPE_VBLUR,				30007;
define SLX3_PPE_SIMPLEBLUR,			30008;
define SLX3_PPE_INVERTCOLOR,			30009;
define SLX3_PPE_MONOCHROM,			30010;
define SLX3_PPE_COMBINE,			30011;
define SLX3_PPE_USERCOMBINE,			30012;
define SLX3_PPE_UPSAMPLE,			30013;

define SLX3USAGE_RENDERTARGET,			0;

endif;